
module demo {
    export interface IUser {
        firstName: string;
        lastName: string;
        isActive?: boolean;
        birthDate?: Date
    }
}

module demoEnhanced {
    import IUser = demo.IUser;

    export interface IDemoEnhanced {
        init: () => void;
        user: IUser;
    }

    export class DemoEnhanced implements IDemoEnhanced {
        init: () => void;
        user: IUser;
        constructor() {
            var userModel: IUser = {
                firstName: "Sergey",
                lastName: "Barskiy"
            };
            this.init = function () {
                $().ready(function () {
                    $("#demoSpan").html(userModel.firstName);
                });
            };
            this.user = userModel;
        }
    }

    export class DemoEnhancedALot extends DemoEnhanced {
        extraFunction: (name: string) => string;
        constructor() {
            super();
            this.extraFunction = (name: string) => {
                return name + "!";
            };
        }
    }
}